Bug 1427984 (CVE-2017-6347) - CVE-2017-6347 kernel: ipv4: Incorrect IP_CHECKSUM handling
Summary: CVE-2017-6347 kernel: ipv4: Incorrect IP_CHECKSUM handling
Status: NEW
Alias: CVE-2017-6347
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard: impact=moderate,public=20170221,repor...
Keywords: Security
Depends On: 1442927 1442944
Blocks: 1427985
TreeView+ depends on / blocked
 
Reported: 2017-03-01 16:14 UTC by Andrej Nemec
Modified: 2019-06-08 21:49 UTC (History)
31 users (show)

(edit)
The skbs processed by ip_cmsg_recv() are not guaranteed to be linear (e.g. when sending UDP packets over loopback with MSGMORE). Using csum_partial() on potentially the whole skb len is dangerous; instead be on the safe side and use skb_checksum().  This may lead to an infoleak as the kernel memory may be checksummed and sent as part of the packet.
Clone Of:
(edit)
Last Closed:


Attachments (Terms of Use)

Description Andrej Nemec 2017-03-01 16:14:44 UTC
The skbs processed by ip_cmsg_recv() are not guaranteed to be linear e.g. when sending UDP packets over loopback with MSGMORE. Using csum_partial() on [potentially] the whole skb len is dangerous; instead be on the safe side and use skb_checksum().

Upstream patch:

http://git.kernel.org/cgit/linux/kernel/git/torvalds/linux.git/commit/?id=ca4ef4574f1ee5252e2cd365f8f5d5bafd048f32

References:

http://seclists.org/oss-sec/2017/q1/525

Comment 1 Fedora Update System 2017-03-03 03:50:18 UTC
kernel-4.9.13-100.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 2 Wade Mealing 2017-03-27 05:27:07 UTC
Statement:

This issue does not affect the Linux kernels as shipped with Red Hat Enterprise Linux 4,5,6,7 and MRG-2.

Comment 5 Wade Mealing 2017-04-18 06:07:05 UTC
Created kernel tracking bugs for this issue:

Affects: fedora-all [bug 1442927]

Comment 7 Justin M. Forbes 2017-04-18 12:40:53 UTC
This was fixed upstream in 4.10.1.  The fix was pushed to Fedora 25 with the 4.10.5 rebase on 3-27 and in Fedora 24 with the 4.10.6 rebase on 4-01.


Note You need to log in before you can comment on or make changes to this bug.